package com.matritel.resttodo.service;

import com.matritel.resttodo.model.Priority;
import com.matritel.resttodo.model.TodoDto;
import com.matritel.resttodo.repository.TodoRepository;
import com.matritel.resttodo.repository.entity.TodoEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.util.List;
import java.util.Optional;

@Service
public class TodoService {

    @Autowired
    private TodoRepository repository;

    // The good method naming convention is that not to use Repository's or Controller's (which = HTTP requests' name) method's names
    public TodoDto create(TodoDto todoInput) {
        //We need to post a DTO object as a response when a user create a request (due to the method signature as well
        //But we just be able to save DAO object into the Database that's why use the builder first
        //And we also need a second convert (builder) to get DTO object to be able to return it
        TodoEntity toSave = toEntity(todoInput);     // first we pass the fields from a TodoDto object to a new TodoEntity object plus add the createdAt field and the ID is autoGenerated because of the annotation in the ToDoEntity class
        //
        TodoEntity saved = repository.save(toSave);  // the save method (implements by the CrudRepository) save the TodoEntity into the database and returns a TodoEntity, that's why we need to create a new Entity object for it
        TodoDto todoDto = toDto(saved); // second we pass the fields from a TodoEntity object (= 'saved') to a new TodoDto object with the new id and createdAt field generated before in the toEntity (because it's the responsibility of repository layer)
        //To convert different objects' state to another we use 'builder' methods.
        // To be able to use these methods wee need to add @Builder annotation for classes what we would like to use

        return todoDto;
    }

    public Optional<TodoEntity> getTodo (String id){
        return repository.findById(id);
    }

    public List<TodoEntity> getAll(){
        return repository.findAll();
    }

    public List<TodoEntity> listTodos(Priority priority){
        return repository.findAllByPriority(priority);
    }

    public List<TodoEntity> listTodos(String personInCharge){
        return repository.findAllByPersonInCharge(personInCharge);
    }

    private TodoDto toDto(TodoEntity saved) {
        return TodoDto.builder()
                .id(saved.getId())
                .description(saved.getDescription())
                .personInCharge(saved.getPersonInCharge())
                .priority(saved.getPriority())
                .createdAt(saved.getCreatedAt())
                .build();
    }

    private TodoEntity toEntity(TodoDto todoInput) {
        return TodoEntity.builder()   // here we build the builder by the created parameters above
                .description(todoInput.getDescription())
                .personInCharge(todoInput.getPersonInCharge())
                .priority(todoInput.getPriority())
                .createdAt(LocalDate.now())
                .build();
    }

    public void deleteTodo(String id) {
        repository.deleteById(id);
    }
}
